//------------------------------------------------------------------------------
// Includes                          
//------------------------------------------------------------------------------

    #include <windows.h>                        // Header pour les Applications Windows
    #include <gl/glut.h>                        // Header OpenGL Utility Toolkit (GLUT)

//------------------------------------------------------------------------------
// Fonction de redimensionnement
//------------------------------------------------------------------------------

void    Reshape(int w,int h)
 {
    glViewport(0,0,w,h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(90,(float)(w)/(float)(h),1,100);
 }

//------------------------------------------------------------------------------
// Fonction d'initialisation
//------------------------------------------------------------------------------

void    InitGL()
 {
    glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
    glClearDepth(1.0f);
    glEnable(GL_COLOR);
 }

//------------------------------------------------------------------------------
// Fonction de dessin
//------------------------------------------------------------------------------

void    Draw()
 {
    float u;
    glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
    glMatrixMode(GL_MODELVIEW);

    glLoadIdentity();
    gluLookAt(0,0,10,0,0,0,0,1,0);

    glColor3f(0.5,1,0.9);

    glBegin(GL_TRIANGLES);
        for (u=0; u<=10; u+=0.5)
         {
        glColor3f(0.5,1,0.9); glVertex3f(u-10,0,0); glColor3f(0.5,0,0.9); glVertex3f(0,u,0);
        glColor3f(0.5,1,0.9); glVertex3f(u-10,0,0); glColor3f(0.5,0,0.9); glVertex3f(0,-u,0);
        glColor3f(0.5,1,0.9); glVertex3f(10-u,0,0); glColor3f(0.5,0,0.9); glVertex3f(0,u,0);
        glColor3f(0.5,1,0.9); glVertex3f(10-u,0,0); glColor3f(0.5,0,0.9); glVertex3f(0,-u,0);
         }
    glEnd();

    glutSwapBuffers();
    glutPostRedisplay();    
 }

//------------------------------------------------------------------------------
// Fonction Principale
//------------------------------------------------------------------------------

int main( int argc, char *argv[ ], char *envp[ ] )
 {
    glutInit(&argc,argv);
    glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
      
    glutInitWindowSize(500,500);
    glutInitWindowPosition (50,50);
    glutCreateWindow("Degrad");

    glutReshapeFunc(Reshape);
    glutDisplayFunc(Draw);
    InitGL();
    glutMainLoop();

    return 0;
 }

//------------------------------------------------------------------------------
// THE END
//------------------------------------------------------------------------------
