//------------------------------------------------------------------------------
// Includes                          
//------------------------------------------------------------------------------

    #include <windows.h>                        // Header pour les Applications Windows
    #include <gl/glut.h>                        // Header OpenGL Utility Toolkit (GLUT)

//------------------------------------------------------------------------------
// Constantes & Variables
//------------------------------------------------------------------------------

    #define COLOR_ARC_EN_CIEL   glColor3f(1.0f*(float)(cos(arc_en_ciel/20.0f)),1.0f*(float)(sin(arc_en_ciel/25.0f)),1.0f-0.5f*(float)(cos(arc_en_ciel/17.0f)))

    float arc_en_ciel = 0.0f;
    
//------------------------------------------------------------------------------
// Fonction de redimensionnement
//------------------------------------------------------------------------------

void    Reshape(int w,int h)
 {
    glViewport(0,0,w,h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(20,(float)(w)/(float)(h),1,100);
 }

//------------------------------------------------------------------------------
// Fonction d'initialisation
//------------------------------------------------------------------------------

void    InitGL()
 {
    glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
    glClearDepth(1.0f);
    glEnable(GL_COLOR);
    glHint(GL_LINE_SMOOTH_HINT, GL_DONT_CARE);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_BLEND);
    glEnable(GL_LINE_SMOOTH);
 }

//------------------------------------------------------------------------------
// Fonction de dessin
//------------------------------------------------------------------------------

void    Draw()
 {
    float u;
    glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
    glMatrixMode(GL_MODELVIEW);
    arc_en_ciel+= 0.1f;                             // Pour la couleur arc-en-ciel
    
    glLoadIdentity();
    gluLookAt(40,40,40,0,0,0,0,1,0);

    COLOR_ARC_EN_CIEL;
    glBegin(GL_LINES);
        for (u=0; u<=10; u+=0.5)
         {
        glVertex3f(u-10,0,0); glVertex3f(0,u,0);
        glVertex3f(u-10,0,0); glVertex3f(0,-u,0);
        glVertex3f(10-u,0,0); glVertex3f(0,u,0);
        glVertex3f(10-u,0,0); glVertex3f(0,-u,0);
        glVertex3f(0,0,u-10); glVertex3f(0,u,0);
        glVertex3f(0,0,u-10); glVertex3f(0,-u,0);
        glVertex3f(0,0,10-u); glVertex3f(0,u,0);
        glVertex3f(0,0,10-u); glVertex3f(0,-u,0);
        glVertex3f(u-10,0,0); glVertex3f(0,0,u);
        glVertex3f(u-10,0,0); glVertex3f(0,0,-u);
        glVertex3f(10-u,0,0); glVertex3f(0,0,u);
        glVertex3f(10-u,0,0); glVertex3f(0,0,-u);

         }
    glEnd();

    glutSwapBuffers();
    glutPostRedisplay();    
 }

//------------------------------------------------------------------------------
// Fonction Principale
//------------------------------------------------------------------------------

int main( int argc, char *argv[ ], char *envp[ ] )
 {
    glutInit(&argc,argv);
    glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
      
    glutInitWindowSize(500,500);
    glutInitWindowPosition (50,50);
    glutCreateWindow("Diamond");

    glutReshapeFunc(Reshape);
    glutDisplayFunc(Draw);
    InitGL();
    glutMainLoop();

    return 0;
 }

//------------------------------------------------------------------------------
// THE END
//------------------------------------------------------------------------------
