//------------------------------------------------------------------------------
// Includes                          
//------------------------------------------------------------------------------

    #include <windows.h>                        // Header pour les Applications Windows
    #include <GL/glut.h>                        // Header OpenGL Utility Toolkit (GLUT)
    #include <math.h>                           // Header mathmatique
    
//------------------------------------------------------------------------------
// Constantes & Variables
//------------------------------------------------------------------------------

    #define COLOR_ARC_EN_CIEL   glColor3f(1.0f*(float)(cos(arc_en_ciel/20.0f)),1.0f*(float)(sin(arc_en_ciel/25.0f)),1.0f-0.5f*(float)(cos(arc_en_ciel/17.0f)))

    float a=0;
    float arc_en_ciel = 0.0f;

//------------------------------------------------------------------------------
// Fonction de redimensionnement
//------------------------------------------------------------------------------

void    Reshape(int w,int h)
 {
    glViewport(0,0,w,h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(90,(float)(w)/(float)(h),1,100);
 }

//------------------------------------------------------------------------------
// Fonction d'initialisation
//------------------------------------------------------------------------------

void    InitGL()
 {
    glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
    glClearDepth(1.0f);
    glEnable(GL_COLOR);
    glHint(GL_LINE_SMOOTH_HINT, GL_DONT_CARE);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_BLEND);
    glEnable(GL_LINE_SMOOTH);
 }

//------------------------------------------------------------------------------
// Fonction de dessin
//------------------------------------------------------------------------------

void    Draw()
 {
    float u, v;
    glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
    glMatrixMode(GL_MODELVIEW);
    a+=0.005;
    arc_en_ciel+= 0.1f;
    
    glLoadIdentity();
    gluLookAt(a,a,8,0,0,0,0,1,0);

    glBegin(GL_LINES);
        for (u=0; u<=10; u++)
         {
        for (v=-10; v<=0; v+=0.1) { arc_en_ciel+= 0.5f; COLOR_ARC_EN_CIEL; glVertex3f(v,tan(atan(u*0.1))*(10+v),0); }
        for (v=-10; v<=0; v+=0.1) { arc_en_ciel+= 0.5f; COLOR_ARC_EN_CIEL; glVertex3f(v,-tan(atan(u*0.1))*(10+v),0); }
        for (v=10; v>=0; v-=0.1) { arc_en_ciel+= 0.5f; COLOR_ARC_EN_CIEL; glVertex3f(v,tan(atan(u*0.1))*(-10+v),0); }
        for (v=10; v>=0; v-=0.1) { arc_en_ciel+= 0.5f; COLOR_ARC_EN_CIEL; glVertex3f(v,-tan(atan(u*0.1))*(-10+v),0); }

        for (v=-10; v<=0; v+=0.1) { arc_en_ciel+= 0.5f; COLOR_ARC_EN_CIEL; glVertex3f(tan(atan(u*0.1))*(10+v),v,0); }
        for (v=-10; v<=0; v+=0.1) { arc_en_ciel+= 0.5f; COLOR_ARC_EN_CIEL; glVertex3f(-tan(atan(u*0.1))*(10+v),v,0); }
        for (v=10; v>=0; v-=0.1) { arc_en_ciel+= 0.5f; COLOR_ARC_EN_CIEL; glVertex3f(tan(atan(u*0.1))*(-10+v),v,0); }
        for (v=10; v>=0; v-=0.1) { arc_en_ciel+= 0.5f; COLOR_ARC_EN_CIEL; glVertex3f(-tan(atan(u*0.1))*(-10+v),v,0); }
         }
    glEnd();

    glutSwapBuffers();
    glutPostRedisplay();    
 }

//------------------------------------------------------------------------------
// Fonction Principale
//------------------------------------------------------------------------------

int main( int argc, char *argv[ ], char *envp[ ] )
 {
    glutInit(&argc,argv);
    glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
      
    glutInitWindowSize(500,500);
    glutInitWindowPosition (50,50);
    glutCreateWindow("Disco");

    glutReshapeFunc(Reshape);
    glutDisplayFunc(Draw);
    InitGL();
    glutMainLoop();

    return 0;
 }

//------------------------------------------------------------------------------
// THE END
//------------------------------------------------------------------------------
