//------------------------------------------------------------------------------
// Includes                          
//------------------------------------------------------------------------------

    #include <windows.h>                        // Header pour les Applications Windows
    #include <gl/glut.h>                        // Header OpenGL Utility Toolkit (GLUT)
    #include <math.h>

//------------------------------------------------------------------------------
// Variables
//------------------------------------------------------------------------------

    float a=0;

//------------------------------------------------------------------------------
// Fonction de redimensionnement
//------------------------------------------------------------------------------

void    Reshape(int w,int h)
 {
    glViewport(0,0,w,h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(90,(float)(w)/(float)(h),1,100);
 }

//------------------------------------------------------------------------------
// Fonction d'initialisation
//------------------------------------------------------------------------------

void    InitGL()
 {
    glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
    glClearDepth(1.0f);
	glEnable(GL_COLOR);
 }

//------------------------------------------------------------------------------
// Fonction de dessin
//------------------------------------------------------------------------------

void    Draw()
 {
    float u, v;
    glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
    glMatrixMode(GL_MODELVIEW);
    a+=0.005;

    glLoadIdentity();
    gluLookAt(a,a,8,0,0,0,0,1,0);

    glBegin(GL_QUADS);
        for (u=0; u<=10; u++) for (v=-10; v<=0; v+=0.5)
         {
            glColor3f(0,1,0.9);
            glVertex3f(v,tan(atan(u*0.1))*(10+v),0);
            glVertex3f(tan(atan(u*0.1))*(10+v),v,0);
            glVertex3f(-tan(atan(u*0.1))*(10+v),v,0);
            glColor3f(0.5,1,0.9);
            glVertex3f(v,-tan(atan(u*0.1))*(10+v),0);

            v = -v;
            glVertex3f(v,-tan(atan(u*0.1))*(-10+v),0);
            glVertex3f(-tan(atan(u*0.1))*(-10+v),v,0);
            glColor3f(0.7,1,0.2);
            glVertex3f(v,tan(atan(u*0.1))*(-10+v),0);
            glVertex3f(tan(atan(u*0.1))*(-10+v),v,0);
            v = -v;
         }

    glEnd();

    glutSwapBuffers();
    glutPostRedisplay();    
 }

//------------------------------------------------------------------------------
// Fonction Principale
//------------------------------------------------------------------------------

int main( int argc, char *argv[ ], char *envp[ ] )
 {
    glutInit(&argc,argv);
    glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
      
    glutInitWindowSize(500,500);
    glutInitWindowPosition (50,50);
    glutCreateWindow("Exotic");

    glutReshapeFunc(Reshape);
    glutDisplayFunc(Draw);
    InitGL();
    glutMainLoop();

    return 0;
 }

//------------------------------------------------------------------------------
// THE END
//------------------------------------------------------------------------------
