//------------------------------------------------------------------------------
// Includes
//------------------------------------------------------------------------------

    #include <windows.h>                            // Header pour les Applications Windows
    #include <stdlib.h>                             // Header pour le random
    #include <gl/glut.h>                            // Header OpenGL Utility Toolkit (GLUT)
    #include <math.h>                               // Header mathmatique

//------------------------------------------------------------------------------
// Constante & Variables
//------------------------------------------------------------------------------

    #define pi          3.1415926535897932384626433832795f // PI pour les angles

    struct points
     {
        float StartX;
        float StartY;
        float InitXVel;
        float InitYVel;
        float intensity;
        float t;
     } point;

//------------------------------------------------------------------------------
// Initialisation d'un point
//------------------------------------------------------------------------------

void InitPoint(points &point)
 {
    float angle=(rand()*30+30)/180.0*pi;
    point.StartX = cos(angle);
    point.StartY = sin(angle);
    point.InitXVel = cos(angle)*10;
    point.InitYVel = sin(angle)*10;
    point.intensity = 1;
    point.t = 0;
 }

//------------------------------------------------------------------------------
// Fonction d'initialisation
//------------------------------------------------------------------------------

void    InitGL()
 {
    glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
    glClearDepth(1.0f);
    glEnable(GL_COLOR);
    glHint(GL_LINE_SMOOTH_HINT, GL_DONT_CARE);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_BLEND);
    glEnable(GL_LINE_SMOOTH);
    glShadeModel(GL_SMOOTH);
 }
 
//------------------------------------------------------------------------------
// Fonction de redimensionnement
//------------------------------------------------------------------------------

void    Reshape(int w,int h)
 {
    glViewport(0, 0, w, h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(90, float(w)/float(h), 1.0, 100.0);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glTranslatef(0.0, 0.0, -20.0);
 }
 
//------------------------------------------------------------------------------
// Fonction de dessin
//------------------------------------------------------------------------------

void    Draw()
 {
    glClear(GL_POLYGON_BIT | GL_COLOR_BUFFER_BIT);
    glPushMatrix();

    float x = 5 * cos(point.t) * 5 * sin(point.t);
    float y = 5 * cos(3*point.t) - 5 * sin(point.t);

    glBegin(GL_LINES);
        glColor3f(point.intensity,point.intensity*0.5,point.intensity*0.3);
        glVertex3f(x, y, 0);
        glColor3f(0.0f,0.0f,0.0f);
        glVertex3f(x-x*0.2,y-y*0.2,0.0f);
    glEnd();
    point.t+=0.056;

    glPopMatrix();
    glutSwapBuffers();
    glutPostRedisplay();
 }
 
//------------------------------------------------------------------------------
// Fonction Principale
//------------------------------------------------------------------------------

int main(int argc, char **argv)
{  
    void randomize(void);
    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE);
    glutInitWindowSize(300, 300);
    glutInitWindowPosition(100, 100);
    glutCreateWindow("Effet No Clear (release 3)");

    InitPoint(point);

    InitGL();
    glutDisplayFunc(Draw);
    glutReshapeFunc(Reshape);
    glutMainLoop();
    return 0;
}

//------------------------------------------------------------------------------
// THE END
//------------------------------------------------------------------------------
