//------------------------------------------------------------------------------
// Includes                          
//------------------------------------------------------------------------------

    #include <windows.h>                        // Header pour les Applications Windows
    #include <stdlib.h>                         // Header du random
    #include <gl/glut.h>                        // Header OpenGL Utility Toolkit (GLUT)
    #include <math.h>                           // Header mathmatique
    
//------------------------------------------------------------------------------
// Constante & Variables
//------------------------------------------------------------------------------

    #define COLOR_ARC_EN_CIEL   glColor3f(1.0f*(float)(cos(arc_en_ciel/20.0f)),1.0f*(float)(sin(arc_en_ciel/25.0f)),1.0f-0.5f*(float)(cos(arc_en_ciel/17.0f)))

    float a=0;
    float arc_en_ciel = 0.0f;

//------------------------------------------------------------------------------
// Fonction de redimensionnement
//------------------------------------------------------------------------------

void    Reshape(int w,int h)
 {
    glViewport(0,0,w,h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(90,(float)(w)/(float)(h),1,100);
 }

//------------------------------------------------------------------------------
// Fonction d'initialisation
//------------------------------------------------------------------------------

void    InitGL()
 {
    glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
    glClearDepth(1.0f);
    glEnable(GL_COLOR);
    glEnable(GL_POINT_SMOOTH);
 }

//------------------------------------------------------------------------------
// Fonction de dessin
//------------------------------------------------------------------------------

void    Draw()
 {
    glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
    glMatrixMode(GL_MODELVIEW);
    a+=0.005;
    arc_en_ciel+= 0.5f;

    glLoadIdentity();
    gluLookAt(a,a,8,0,0,0,0,1,0);

    float tmp = arc_en_ciel, u, v;
    for (u=0; u<=10; u++)
     {
        for (v=-10; v<=0; v+=0.1) { arc_en_ciel+= 0.005f; COLOR_ARC_EN_CIEL; glPointSize(rand()*0.0001); glBegin(GL_POINTS); glVertex3f(v,tan(atan(u*0.1))*(10+v),0); glEnd(); }
        for (v=-10; v<=0; v+=0.1) { arc_en_ciel+= 0.005f; COLOR_ARC_EN_CIEL; glPointSize(rand()*0.0001); glBegin(GL_POINTS); glVertex3f(v,-tan(atan(u*0.1))*(10+v),0); glEnd(); }
        for (v=10; v>=0; v-=0.1) { arc_en_ciel+= 0.005f; COLOR_ARC_EN_CIEL; glPointSize(rand()*0.0001); glBegin(GL_POINTS); glVertex3f(v,tan(atan(u*0.1))*(-10+v),0); glEnd(); }
        for (v=10; v>=0; v-=0.1) { arc_en_ciel+= 0.005f; COLOR_ARC_EN_CIEL; glPointSize(rand()*0.0001); glBegin(GL_POINTS); glVertex3f(v,-tan(atan(u*0.1))*(-10+v),0); glEnd(); }
        
        for (v=-10; v<=0; v+=0.1) { arc_en_ciel+= 0.005f; COLOR_ARC_EN_CIEL; glPointSize(rand()*0.0001); glBegin(GL_POINTS); glVertex3f(tan(atan(u*0.1))*(10+v),v,0); glEnd(); }
        for (v=-10; v<=0; v+=0.1) { arc_en_ciel+= 0.005f; COLOR_ARC_EN_CIEL; glPointSize(rand()*0.0001); glBegin(GL_POINTS); glVertex3f(-tan(atan(u*0.1))*(10+v),v,0); glEnd(); }
        for (v=10; v>=0; v-=0.1) { arc_en_ciel+= 0.005f; COLOR_ARC_EN_CIEL; glPointSize(rand()*0.0001); glBegin(GL_POINTS); glVertex3f(tan(atan(u*0.1))*(-10+v),v,0); glEnd(); }
        for (v=10; v>=0; v-=0.1) { arc_en_ciel+= 0.005f; COLOR_ARC_EN_CIEL; glPointSize(rand()*0.0001); glBegin(GL_POINTS); glVertex3f(-tan(atan(u*0.1))*(-10+v),v,0); glEnd(); }
     }

    arc_en_ciel = tmp + 0.1;
    
    glutSwapBuffers();
    glutPostRedisplay();    
 }

//------------------------------------------------------------------------------
// Fonction Principale
//------------------------------------------------------------------------------

int main( int argc, char *argv[ ], char *envp[ ] )
 {
    glutInit(&argc,argv);
    glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
      
    glutInitWindowSize(500,500);
    glutInitWindowPosition (50,50);
    glutCreateWindow("Pointeur");

    glutReshapeFunc(Reshape);
    glutDisplayFunc(Draw);
    InitGL();
    glutMainLoop();

    return 0;
 }

//------------------------------------------------------------------------------
// THE END
//------------------------------------------------------------------------------
