
//------------------------------------------------------------------------------
// Includes                          
//------------------------------------------------------------------------------

    #include <windows.h>                        // Header pour les Applications Windows
    #include <gl/glut.h>                        // Header OpenGL Utility Toolkit (GLUT)
    #include <string.h>                         // Header pour sprintf
    #include <math.h>

//------------------------------------------------------------------------------
// Constantes & Variables
//------------------------------------------------------------------------------

    #define EXIT {fclose(fichier);return -1;}   // ferme un fichier
    #define CTOI(C) (*(int*)&C)                 // rcupre en int un nombre point par un char*
    #define TaillePoint 2
    #define IntA        1      // interval axe
    #define IntC        0.01   // interval courbe

    int EcranPiX, EcranPiY;
    float x, y;
    float MinX = -10;
    float MaxX = 10;
    float MinY = -10;
    float MaxY = 10;
    float Echelle = 25;
    
//------------------------------------------------------------------------------
// Menu : Slection du Minimum en X
//------------------------------------------------------------------------------   

void selectMinX(int selection)
 {
    switch (selection)
     {
        case 11 : MinX = -10; break ;
        case 12 : MinX = -5; break ;
        case 13 : MinX = 5; break ;
        case 14 : MinX = -10; break ;
     }
    EcranPiX = (int)(Echelle*(MaxX-MinX));
    EcranPiY = (int)(Echelle*(MaxY-MinY));
    glutReshapeWindow(EcranPiX,EcranPiY);
 }

//------------------------------------------------------------------------------
// Menu : Slection du Maximum en X
//------------------------------------------------------------------------------   

void selectMaxX(int selection)
 {
    switch (selection)
     {
        case 21 : MaxX = -5; break ;
        case 22 : MaxX = 0; break ;
        case 23 : MaxX = 10; break ;
        case 24 : MaxX = 15; break ;
     }
    EcranPiX = (int)(Echelle*(MaxX-MinX));
    EcranPiY = (int)(Echelle*(MaxY-MinY));
    glutReshapeWindow(EcranPiX,EcranPiY);
 }
 
//------------------------------------------------------------------------------
// Menu : Slection du Minimum en Y
//------------------------------------------------------------------------------    
 
void selectMinY(int selection)
 {
    switch (selection)
     {
        case 31 : MinY = -10; break ;
        case 32 : MinY = -5; break ;
        case 33 : MinY = 5; break ;
        case 34 : MinY = -10; break ;
     }
    EcranPiX = (int)(Echelle*(MaxX-MinX));
    EcranPiY = (int)(Echelle*(MaxY-MinY));
    glutReshapeWindow(EcranPiX,EcranPiY);
 }
 
//------------------------------------------------------------------------------
// Menu : Slection du Maximum en Y
//------------------------------------------------------------------------------   
 
void selectMaxY(int selection)
 {
    switch (selection)
     {
        case 41 : MaxY = -5; break ;
        case 42 : MaxY = 0; break ;
        case 43 : MaxY = 10; break ;
        case 44 : MaxY = 15; break ;
     }
    EcranPiX = (int)(Echelle*(MaxX-MinX));
    EcranPiY = (int)(Echelle*(MaxY-MinY));
    glutReshapeWindow(EcranPiX,EcranPiY);
 }
 
//------------------------------------------------------------------------------
// Menu : Slection de l'chelle
//------------------------------------------------------------------------------    
 
void selectEchelle(int selection)
 {
    switch (selection)
     {
        case 51 : Echelle *= 0.25; break ;
        case 52 : Echelle *= 0.5; break ;
        case 53 : Echelle *= 2; break ;
        case 54 : Echelle *= 4; break ;
     }
    EcranPiX = (int)(Echelle*(MaxX-MinX));
    EcranPiY = (int)(Echelle*(MaxY-MinY));
    glutReshapeWindow(EcranPiX,EcranPiY);
 }
 
//------------------------------------------------------------------------------
// Menu : Quitter
//------------------------------------------------------------------------------    

void selectMenu (int selection)
 {
    switch (selection)
     {
        case 0  : exit(0);
     }
    glutPostRedisplay();
 }

//------------------------------------------------------------------------------
// Fonction de redimensionnement
//------------------------------------------------------------------------------

void    Reshape(int w,int h)
 {
    glViewport(0,0,w,h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(90,(float)(w)/(float)(h),1,100);
 }

//------------------------------------------------------------------------------
// Fonction d'initialisation
//------------------------------------------------------------------------------

void    InitGL()
 {
    glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
    glClearDepth(1.0f);    
    glPointSize(TaillePoint);
 }

//------------------------------------------------------------------------------
// Fonction de dessin
//------------------------------------------------------------------------------

void    Draw()
 {
    glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
    glMatrixMode(GL_MODELVIEW);

    float GLAvarx=MinX+(MaxX-MinX)*0.5; // milieu axe X (-5 et 15 donne 5)
    float GLAvary=MinY+(MaxY-MinY)*0.5; // milieu axe Y (10 et 20 donne 15)
    float GLAvarz;                      // recul Z  faire pour que la camra voit tout
    (GLAvarx-MinX<GLAvary-MinY)?(GLAvarz=GLAvarx-MinX):(GLAvarz=GLAvary-MinY);
    
    glLoadIdentity();
    gluLookAt(GLAvarx,GLAvary,GLAvarz,GLAvarx,GLAvary,0,0,1,0);

    glBegin(GL_POINTS);
        // axe X
        glColor3d(1,0,0); for (x=MinX;x<MaxX;x+=IntA) glVertex3f(x,0,0);
        // axeY
        glColor3d(0,1,0); for (y=MinY;y<MaxY;y+=IntA) glVertex3f(0,y,0);      
        // courbes
        for (x=MinX;x<MaxX;x+=IntC)
         {
            y = x; glColor3d(1,1,0); glVertex3f(x,y,0);
            y = pow(x, 2); glColor3d(1,0,1); glVertex3f(x,y,0);
            y = cos(x); glColor3d(0,1,1); glVertex3f(x,y,0);
            y = 1/x; glColor3d(0,0,1); glVertex3f(x,y,0);       
         }
    glEnd();

    glutSwapBuffers();
    glutPostRedisplay();    
 }

//------------------------------------------------------------------------------
// Fonction Principale
//------------------------------------------------------------------------------

int main( int argc, char *argv[ ], char *envp[ ] )
 {
    EcranPiX = (int)(Echelle*(MaxX-MinX));
    EcranPiY = (int)(Echelle*(MaxY-MinY));
 
    glutInit(&argc,argv);
    glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
      
    glutInitWindowSize(EcranPiX,EcranPiY);
    glutInitWindowPosition (50,50);    
    glutCreateWindow("Trace");
    
    int MenuMinX = glutCreateMenu(selectMinX);
    glutAddMenuEntry("-10 (defaut)",11);
    glutAddMenuEntry("-5",12);
    glutAddMenuEntry("5",13);
    glutAddMenuEntry("10",14);
    int MenuMaxX = glutCreateMenu(selectMaxX);
    glutAddMenuEntry("-5",21);
    glutAddMenuEntry("0",22);
    glutAddMenuEntry("10 (defaut)",23);
    glutAddMenuEntry("15",24);
    int MenuMinY = glutCreateMenu(selectMinY);
    glutAddMenuEntry("-10 (defaut)",31);
    glutAddMenuEntry("-5",32);
    glutAddMenuEntry("5",33);
    glutAddMenuEntry("10",34);
    int MenuMaxY = glutCreateMenu(selectMaxY);
    glutAddMenuEntry("-5",41);
    glutAddMenuEntry("0",42);
    glutAddMenuEntry("10 (defaut)",43);
    glutAddMenuEntry("15",44);
    int MenuEchelle = glutCreateMenu(selectEchelle);
    glutAddMenuEntry("x 0.25",51);
    glutAddMenuEntry("x 0.5",52);
    glutAddMenuEntry("x 2",53);
    glutAddMenuEntry("x 4",54);
    glutCreateMenu(selectMenu);
    glutAddSubMenu("MinX",MenuMinX);
    glutAddSubMenu("MaxX",MenuMaxX);
    glutAddSubMenu("MinY",MenuMinY);
    glutAddSubMenu("MaxY",MenuMaxY);
    glutAddSubMenu("Echelle",MenuEchelle);
    glutAddMenuEntry("Quitter",0);
    glutAttachMenu(GLUT_RIGHT_BUTTON);

    glutReshapeFunc(Reshape);
    glutDisplayFunc(Draw);
    InitGL();
    glutMainLoop();

    return 0;
 }

//------------------------------------------------------------------------------
// THE END
//------------------------------------------------------------------------------
